//
//      SAXParser.hpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.1.
//

#ifndef __SAXPARSER_HPP
#define __SAXPARSER_HPP

#define TARGET_BUILD_DEBUG
#include <SophiaFramework.hpp>

// {
SFMTYPEDEFSTRUCT(ItemAttributesRec)
struct ItemAttributesRec {
	SFXAnsiString binding;				// {̎
	SFXProperty creator;				// 
	SInt32 amount;						// li
	SFXAnsiString currencyCode;			// ʉݒP
	SFXAnsiString formattedPrice;		// z
	SInt32 numberOfPages;				// y[W
	SInt32 packageDimensionsLength;		// 
	SInt32 packageDimensionsWidth;		// 
	SFXAnsiString productGroup;			// {
	SFXDate publicationDate;			// 
	SFXAnsiString publisher;			// oŎ
};

// 摜	
SFMTYPEDEFSTRUCT(ImageUrlRec)
struct ImageUrlRec {
	SFXAnsiString smallImageURL;		// JPG t@C URL
	SInt32 smallImageHeight;            // 摜̍ (sNZP)
	SInt32 smallImageWidth;				// 摜̕ (sNZP)
	SFXAnsiString mediumImageURL;		// JPG t@C URL
	SInt32 mediumImageHeight;			// 摜̍ (sNZP)
	SInt32 mediumImageWidth;			// 摜̕ (sNZP)
	SFXAnsiString largeImageURL;		// JPG t@C URL
	SInt32 largeImageHeight;			// 摜̍ (sNZP)
	SInt32 largeImageWidth;				// 摜̕ (sNZP)
};

// r[( e )
SFMTYPEDEFSTRUCT(ReviewRec)
struct ReviewRec {
	SFXAnsiString asin;					// ISBN ԍ
	SInt32 rating;						// rA[̕]
	SInt32 helpfulVotes;				// ]l
	SFXAnsiString customerId;			// customer Id
	SInt32 totalVotes;					// g[^̓[l
	SFXDate date;						// r[t
	SFXAnsiString summary;				// Tv
	SFXAnsiString content;				// e
};

// r[( Tv )
SFMTYPEDEFSTRUCT(CustomerReviewsRec)
struct CustomerReviewsRec {
	SInt32 avarageRating;				// ϕ]
	SInt32 totalReviews;				// r[l
	SInt32 totalReviewPages;			// r[y[W
	SFXArray<ReviewRecPtr> reviews;		// r[e
};

// ގi( e )
SFMTYPEDEFSTRUCT(SimilarProductRec)
struct SimilarProductRec {
	SFXAnsiString asin;					// ISBN ԍ
	SFXAnsiString title;				// ^Cg
};

// ގi( Tv )
SFMTYPEDEFSTRUCT(SimilarProductsRec)
struct SimilarProductsRec {
	SFXArray<SimilarProductRecPtr> similarProducts;	// ގi( e )
};

// Not yet implimentation.
SFMTYPEDEFSTRUCT(OfferSummaryRec)
struct OfferSummaryRec {
	SInt32 lowestNewPrice;				
	SFXAnsiString currencyCode;			
	SFXAnsiString formattedPrice;		
	SInt32 totalNew;					
	SInt32 totalUsed;					
	SInt32 totalCollectible;			
	SInt32 totalRefurbished;
};
 
// Not yet implimentation.
SFMTYPEDEFSTRUCT(OfferRec)
struct OfferRec {
	SFXAnsiString merchantId;
	SFXAnsiString condition;
	SFXAnsiString offerListingId;
	SInt32 amount;
	SFXAnsiString CurrencyCode;
	SFXAnsiString formattedPrice;
};

// Not yet implimentation.
SFMTYPEDEFSTRUCT(OffersRec)
struct OffersRec {
	SInt32 totalOffers;
	SInt32 totalOfferspages;
	SFXArray<OfferRecPtr> offers;
};
  
// Not yet implimentation.
SFMTYPEDEFSTRUCT(BrowserNodesRec)
struct BrowserNodesRec {
	SFXAnsiString dummy;
};

// Not yet implimentation.
SFMTYPEDEFSTRUCT(ListmaniaListsRec)
struct ListmaniaListsRec {
	SFXAnsiString dummy;
};

SFMTYPEDEFCLASS(SAXParser)
class SAXParser : public SFXXMLDefaultHandler {

public:
    explicit SAXParser(Void);
    virtual ~SAXParser(Void);

	static SFXAnsiString GetUrlForISBNSsarch(SFXAnsiStringConstRef isbn);
    
    Void SetParseImageUrl(Bool param) { _isParseImageUrl = param; }
    Void SetParseCustomerReviews(Bool param) { _isParseCustomerReviews = param; }
    Void SetParseSimilarProducts(Bool param) { _isParseSimilarProducts = param; }

	Bool GetXMLerror(Void) { return _xmlerrorflg; }

    SFXAnsiStringConstRef GetAsin(Void) { return _asin; }
    SFXAnsiStringConstRef GetTitle(Void) { return _title; }

    ItemAttributesRecConstPtr GetItemAttributes(Void) { return _itemAttributes; }
    ImageUrlRecConstPtr GetImageUrl(Void) { return _imageUrl; }
    CustomerReviewsRecConstPtr GetCustomerReviews(Void) { return _customerReviews; }
    SimilarProductsRecConstPtr GetSimilarProducts(Void) { return _similarProducts; }

public:
    // interface for ContentHandler
    virtual Void Characters(SFXAnsiStringConstRef string, BoolConst cdataSection = true);
    virtual Void EndDocument(Void);
    virtual Void EndElement(SFXAnsiStringConstRef uri = "", SFXAnsiStringConstRef localname = "", SFXAnsiStringConstRef qname = "");
    virtual Void StartDocument(Void);
    virtual Void StartElement(SFXAnsiStringConstRef uri, SFXAnsiStringConstRef localname, SFXAnsiStringConstRef qname, SFXXMLGrammar::XMLAttrListConstRef attrList);
    virtual Void IgnorableWhitespace(SFXAnsiStringConstRef string);
    virtual Void ProcessingInstruction(SFXAnsiStringConstRef target, SFXAnsiStringConstRef data);
    virtual Void EndPrefixMapping(SFXAnsiStringConstRef prefix);
    virtual Void StartPrefixMapping(SFXAnsiStringConstRef prefix, SFXAnsiStringConstRef uri);

    // interface for LexicalHandler
    virtual Void Comment(SFXAnsiStringConstRef string);
    virtual Void EndCDATA(Void);
    virtual Void EndDTD(Void);
    virtual Void EndEntity(SFXAnsiStringConstRef name);
    virtual Void StartCDATA(Void);
    virtual Void StartDTD(SFXAnsiStringConstRef name, SFXAnsiStringConstRef publicId, SFXAnsiStringConstRef systemId);
    virtual Void StartEntity(SFXAnsiStringConstRef name);

    // interface for DTDHandler
    virtual Void NotationDecl(SFXAnsiStringConstRef name, SFXAnsiStringConstRef publicId, SFXAnsiStringConstRef systemId);
    virtual Void UnparsedEntityDecl(SFXAnsiStringConstRef name, SFXAnsiStringConstRef publicId, SFXAnsiStringConstRef systemId, SFXAnsiStringConstRef notationName);

    // interface for DeclHandler
    virtual Void ElementDecl(SFXAnsiStringConstRef name, SFXAnsiStringConstRef model);
    virtual Void AttributeDecl(SFXAnsiStringConstRef ename, SFXAnsiStringConstRef aname, SFXAnsiStringConstRef type, SFXAnsiStringConstRef mode, SFXAnsiStringConstRef value);
    virtual Void InternalEntityDecl(SFXAnsiStringConstRef name, SFXAnsiStringConstRef value);
    virtual Void ExternalEntityDecl(SFXAnsiStringConstRef name, SFXAnsiStringConstRef publicId, SFXAnsiStringConstRef systemId);

    // others functions
    virtual Void ErrorReport(SFCErrorConst error, SFXAnsiStringConstRef errInfo); 

	SFXDate StringToDate(SFXAnsiStringConstRef string);
	Void Clear(Void);

private:
    Bool	_isParseItemAttributes;
    Bool	_isParseImageUrl;
    Bool	_isParseOfferSummary;
    Bool	_isParseOffers;
    Bool	_isParseCustomerReviews;
    Bool	_isParseSimilarProducts;
    Bool	_isParseBrowserNodes;
    Bool	_isParseListmaniaLists;

	enum KindOfImage {NOTHING, SMALL, MEDIUM, LARGE};
	KindOfImage _kind;

	Bool _packageDimensionsflg;
	Bool _similarProductflg;
	Bool _itemflg;
	Bool _itemAttributesflg;
	Bool _characterGetflg;
	Bool _xmlerrorflg;

	SFXAnsiString	_characters;
	SFXAnsiString	_values;
	SFXAnsiString	_asin;
    SFXAnsiString	_detailPageURL;
    SFXAnsiString	_title;
	SInt32			_salesRank;


	// ߖ̂߃|C^Ƃĕێ
    ItemAttributesRecPtr	_itemAttributes;
    ImageUrlRecPtr			_imageUrl;
    OfferSummaryRecPtr		_offerSummary;
    OffersRecPtr			_offers;
    CustomerReviewsRecPtr	_customerReviews;
    SimilarProductsRecPtr	_similarProducts;
    BrowserNodesRecPtr		_browserNodes;
    ListmaniaListsRecPtr	_listmaniaLists;
	ReviewRecPtr			_review;
	SimilarProductRecPtr	_similarProduct;
};

#endif // __SAXPARSER_HPP //
